#include <iostream>
#include <fstream>
#include <vector>
#include <stdlib.h>

using namespace std;

static const int primesLength = 30 ;
static const int primes[] = { 2,  3,  5,  7, 11,  13,  17,  19,  23,  29,
                             31, 37, 41, 43, 47,  53,  59,  61,  67,  71,
                             73, 79, 83, 89, 97, 101, 103, 107, 109, 113} ;

class MinionPrimeQueenInstanceGenerator {
  int noPrimesInThisInstance ;
  int indexOfFirstBoundsVar ;
  int indexOfFirstSparseBoundsVar ;
  int indexOfFirstDiscreteVar ;
  int indexOfFirstSparseDiscreteVar ;

  void generateVars(int n) ;
  void generateVarOrder(int n) ;
  void generateValOrder(int n) ;
  void generateMatrices(int n) ;
  void generateTuples(int n) ;
  void generateObjective(int n) ;
  void generateConstraints(int n) ;
  void generateTuplesAdjacentVals(int n) ;
  void generateTuplesQueenPrimes(int n) ;
  void generateTupleBinary(bool needComma, int c1, int c2) ;
  void generateTupleTernary(bool needComma, int c1, int c2, int c3) ;
 public:
  void generate(int n) ;
};
